"{ Package: 'jv:calipel/s/benchmarks/stx' }"

Benchmark subclass:#BenchmarkCollection
	instanceVariableNames:'collectionClass collectionDatasetSize collectionDataset1
		collectionDataset2 collectionDataset3 collection
		collectionDataset1OrderedAsc collectionDataset1OrderedDesc'
	classVariableNames:''
	poolDictionaries:''
	category:'CalipeL-S-Benchmarks-St/X'
!


!BenchmarkCollection class methodsFor:'testing'!

isAbstract
    ^ self == BenchmarkCollection

    "Created: / 09-03-2014 / 10:34:48 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkCollection methodsFor:'parameters'!

collectionClassName
    ^ collectionClass name

    "Modified (format): / 09-03-2014 / 10:00:45 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

collectionClassName:aSymbol
    <parameter: 'Collection class name to benchmark' type: #Symbol values: #(#' * must be defined in subclass *')>

    collectionClass := Smalltalk at: aSymbol asSymbol.
    collectionClass isNil ifTrue:[ 
        self error:'No such class: ', aSymbol
    ].

    "Created: / 09-03-2014 / 11:07:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

collectionDatasetSize
    ^ collectionDatasetSize

    "Created: / 10-03-2014 / 00:13:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

collectionDatasetSize:anInteger
    <parameter: 'Size of a collection' type: #Integer default: 100000>
    collectionDatasetSize := anInteger.

    "Created: / 10-03-2014 / 00:13:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkCollection methodsFor:'running'!

setUp
    <setup>

    | random seen generator |

    random := Random new setSeed: 12345.
    seen := Set new.
    generator := [ 
        | x |

        x := random nextInteger.
        [ seen includes: x ] whileTrue:[ 
            x := random nextInteger.
        ].
        seen add: x.
        x
    ].


    collectionDataset1 := (1 to: collectionDatasetSize) collect:[:i | generator value ].
    self assert: seen size = collectionDatasetSize.        
    collectionDataset2 := nil. "/ unused.
    collectionDataset3 := nil. "/ unused.
    Smalltalk garbageCollect.
    collection := nil.

    "Created: / 09-03-2014 / 10:10:49 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-03-2014 / 00:17:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

tearDown
    <teardown>

    collectionDataset1 := nil.
    collectionDataset2 := nil.
    collectionDataset3 := nil.
    Smalltalk garbageCollect.
    collection := nil.

    "Created: / 09-03-2014 / 10:12:34 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-03-2014 / 00:17:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkCollection methodsFor:'setup'!

setUpCollectionDataset1OrderedAsc
    collectionDataset1OrderedAsc := collectionDataset1 copy sort.

    "Created: / 09-03-2014 / 10:28:55 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

setUpCollectionDataset1OrderedDesc
    collectionDataset1OrderedDesc := collectionDataset1 copy sort reverse

    "Created: / 09-03-2014 / 10:29:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkCollection class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

