"{ Package: 'jv:calipel/s/tests' }"

TestCase subclass:#BenchmarkInstanceTestsA
	instanceVariableNames:'log param1 param2'
	classVariableNames:''
	poolDictionaries:''
	category:'CalipeL-S-Tests'
!


!BenchmarkInstanceTestsA methodsFor:'benchmarks'!

fake01
    <benchmark>
    log add:#'fake01'

    "Created: / 27-05-2013 / 22:08:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 09-03-2014 / 22:55:38 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

fake02
    <benchmark>
    log add:#'fake02' add:param1

    "Created: / 27-05-2013 / 23:28:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 09-03-2014 / 22:55:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

fake03a
    <benchmark>
    <setup: #fakeSetUp1>
    log add:#'fake03'

    "Created: / 09-03-2014 / 23:35:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

fake03b
    <benchmark>
    <setup: #(#fakeSetUp1 #fakeSetUp2)>
    log add:#'fake03'

    "Created: / 09-03-2014 / 23:35:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

fake04a
    <benchmark>
    <teardown: #fakeTearDown1>
    log add:#'fake03'

    "Created: / 09-03-2014 / 23:36:03 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

fake04b
    <benchmark>
    <teardown: #(#fakeTearDown1 #fakeTearDown2)>
    log add:#'fake03'

    "Created: / 09-03-2014 / 23:35:36 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

fakeSetUp
    <setup>
    log add:#'fakeSetUp'

    "Created: / 28-05-2013 / 08:34:16 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 09-03-2014 / 22:56:46 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

fakeSetUp1
    log add:#'fakeSetUp1'

    "Created: / 09-03-2014 / 22:52:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

fakeSetUp2
    log add:#'fakeSetUp2'

    "Created: / 09-03-2014 / 22:52:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

fakeTearDown1
    log add:#'fakeTearDown1'

    "Created: / 09-03-2014 / 22:52:34 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

fakeTearDown2
    log add:#'fakeTearDown2'

    "Created: / 09-03-2014 / 22:52:38 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkInstanceTestsA methodsFor:'parameters'!

param1
    ^ param1
!

param1:anInteger
    <parameter: #param1 type: #Integer default: 1234>

    param1 := anInteger.

    "Modified: / 27-07-2013 / 13:02:16 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

param2
    ^ param2
!

param2:anInteger
    <parameter: #param2 type: #Integer default: 9876 values: #(1234 9876)>

    param2 := anInteger.

    "Modified: / 27-07-2013 / 13:08:16 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkInstanceTestsA methodsFor:'running'!

setUp
    log := OrderedCollection new.

    "Created: / 27-05-2013 / 22:08:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkInstanceTestsA methodsFor:'tests'!

test_01

    | b r |

    b := BenchmarkInstance new instance:self selector:#fake01.
    r := b run.

    self assert: r outcomes size == 1.
    self assert: r outcomes anyOne benchmark == b.
    self assert: log asArray = #(#fakeSetUp #fake01 "<--warmup" #fakeSetUp #fake01 ).

    "Created: / 27-05-2013 / 22:08:03 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-03-2014 / 10:13:22 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_02

    self 
        should: [BenchmarkInstance class:self class selector:#'non_existent_benchmark']
        raise: Error

    "Created: / 27-05-2013 / 22:13:41 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_03a

    | b r |

    b := BenchmarkInstance new instance:self selector:#'fake01'.
    r := b run: BenchmarkResult new with: Dictionary new.

    self assert: param1 == 1234

    "Created: / 28-05-2013 / 00:04:06 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 30-07-2013 / 23:10:24 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_03b

    | b r |

    b := BenchmarkInstance new instance:self selector:#'fake01'.
    r := b run: BenchmarkResult new with: (Dictionary new at: #param1 put: '4321'; yourself).

    self assert: param1 == 4321

    "Created: / 28-05-2013 / 00:05:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 30-07-2013 / 23:10:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_03c

    | b r |

    b := BenchmarkInstance new instance:self selector:#'fake01'.
        r := b run: BenchmarkResult new with: (Dictionary new at: #'BenchmarkInstanceTests#param1' put: '1234'; yourself).

    self assert: param1 == 1234

    "Created: / 28-05-2013 / 00:05:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 30-07-2013 / 23:10:29 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_03d

    | b r |

    b := BenchmarkInstance new instance:self selector:#'fake01'.
    r := b run: BenchmarkResult new with: (Dictionary new
                        at: #'param1' put: '9876'; 
                        at: #'BenchmarkInstanceTestsA#param1' put: '1234'; yourself).

    self assert: param1 == 1234

    "Created: / 28-05-2013 / 00:06:11 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 30-07-2013 / 23:13:11 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_03e

    | b |

    b := BenchmarkInstance new instance:self selector:#'fake01'.
    self should: [
        b runWith: (Dictionary new 
                        at: #'param2' put: '5555'; yourself).
    ] raise: BenchmarkParameterError.

    "Created: / 28-05-2013 / 00:11:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 30-07-2013 / 23:10:34 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_03f

    | b |

    b := BenchmarkInstance new instance:self selector:#'fake01'.
    self should: [
        b runWith: (Dictionary new 
                        at: #'param1' put: 'asdf'; yourself).
    ] raise: BenchmarkParameterError.

    "Created: / 28-05-2013 / 00:12:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 30-07-2013 / 23:10:36 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_04a

    | b r |

    b := BenchmarkInstance new instance:self selector:#'fake01'.
    r := b runWith:(Dictionary new at: 'param1' put:'10,20'; yourself).

    self assert: r outcomes size == 2.
    self assert: r outcomes first benchmark == b.
    self assert: r outcomes second benchmark == b.
    self assert: log asArray = #(#fakeSetUp #fake01 "<--warmup" #fakeSetUp #fake01 #fakeSetUp #fake01 "<--warmup" #fakeSetUp #fake01).

    "Created: / 27-07-2013 / 13:19:19 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-03-2014 / 10:13:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_04b

    | b r |

    b := BenchmarkInstance new instance:self selector:#'fake01'.
    r := b runWith:(Dictionary new at: 'param1' put:'10,20'; at: 'param2' put:'1234,9876'; yourself).

    self assert: r outcomes size == 4.
    self assert: r outcomes first benchmark == b.
    self assert: r outcomes second benchmark == b.

    "Created: / 27-07-2013 / 13:20:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 30-07-2013 / 23:10:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_05a
    "Tests per-benchmark setup/teardown"

    | b r |

    b := BenchmarkInstance new instance:self selector:#'fake03a'.
    r := b run.

    self assert: log asArray = #(#fakeSetUp #fakeSetUp1 #fake03"<--warmaup" #fakeSetUp #fakeSetUp1 #fake03)

    "Created: / 09-03-2014 / 22:53:17 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-03-2014 / 10:14:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_05b
    "Tests per-benchmark setup/teardown"

    | b r |

    b := BenchmarkInstance new instance:self selector:#'fake03b'.
    r := b run.

    self assert: log asArray = #(#fakeSetUp #fakeSetUp1 #fakeSetUp2 #fake03"<--warmaup" #fakeSetUp #fakeSetUp1 #fakeSetUp2 #fake03)

    "Created: / 09-03-2014 / 22:58:15 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-03-2014 / 10:14:19 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_06a
    "Tests per-benchmark setup/teardown"

    | b r |

    b := BenchmarkInstance new instance:self selector:#'fake04a'.
    r := b run.

    self assert: log asArray = #(#fakeSetUp #fake03 #fakeTearDown1"<--warmaup" #fakeSetUp #fake03 #fakeTearDown1)

    "Created: / 09-03-2014 / 23:36:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-03-2014 / 10:14:39 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

test_06b
    "Tests per-benchmark setup/teardown"

    | b r |

    b := BenchmarkInstance new instance:self selector:#'fake04b'.
    r := b run.

    self assert: log asArray = #(#fakeSetUp #fake03 #fakeTearDown1 #fakeTearDown2"<--warmaup" #fakeSetUp #fake03 #fakeTearDown1 #fakeTearDown2)

    "Created: / 09-03-2014 / 23:36:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-03-2014 / 10:14:57 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkInstanceTestsA class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

